Option Explicit On
Option Strict On

Public Class Form1

    ' validate an integer value - general - will do any integer with max and min
    '   Input - text string input
    '   Output - Direct - boolean indicating if ok or not
    '            Indirect - converted number  
    Private Function ValidateInteger(ByVal inputStr As String, ByRef output As Integer, ByVal min As Integer, ByVal max As Integer, ByVal thing As String) As Boolean
        Dim isOk As Boolean
        ' convert text
        isOk = Integer.TryParse(inputStr, output)
        If isOk Then
            If output < min OrElse output > max Then
                MsgBox("Please enter a number of " & thing & " between " & min & " and " & max)
                isOk = False
            End If
        Else
            MsgBox("Please enter a whole number for number of " & thing)
        End If
        Return isOk
    End Function

    Private Function updateBalance(ByVal amount As Integer, ByRef bal As Integer) As Boolean
        If amount <= bal Then
            ' can subtract
            bal = bal - amount
            Return True
        Else
            Return False
        End If
    End Function

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim balance As Integer = 1000
    End Sub

    Private Sub btnSub_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSub.Click

        Dim isOk As Boolean
        Dim toSub As Integer
        Dim isSuccessful As Boolean
        isOk = ValidateInteger(TxtToSubtract.Text, toSub, 1, balance, "to subtract")
        If isOk Then
            isSuccessful = updateBalance(toSub, balance)
        End If
    End Sub

    Private Sub BtnShow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnShow.Click
        MsgBox("current balance is " & balance)
    End Sub

    Private Sub btnQuit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnQuit.Click
        Me.Close()

    End Sub
End Class
